<?php

namespace UnicaenZimbra\Options;

use Interop\Container\ContainerInterface;
use Laminas\ServiceManager\Factory\FactoryInterface;

class ModuleOptionsFactory implements FactoryInterface
{
    /**
     * Create service
     *
     * @param ContainerInterface $container
     * @param string $requestedName
     * @param array|null $options
     * @return ModuleOptions|object
     */
    public function __invoke(ContainerInterface $container, $requestedName, array $options = null)
    {
        $config = $container->get('Configuration');
        $moduleConfig = isset($config['unicaen-zimbra']) ? $config['unicaen-zimbra'] : array();
        return new ModuleOptions($moduleConfig);
    }
}