<?php

namespace UnicaenZimbraTest\Service;

use UnicaenZimbra\Entity\Account;

/**
 * @group Entity
 */
class EntityTest extends \PHPUnit_Framework_TestCase
{

    protected $account;

    protected $xmlData = '<GetAccountResponse xmlns="urn:zimbraAdmin"><account id="01d13c21-2d2c-45f9-9df0-9bee295b3542" name="laurent.lecluse@pp.unicaen.fr"><a n="zimbraMobilePolicyAllowUnsignedApplications">1</a><a n="zimbraPrefMailFlashTitle">FALSE</a><a n="zimbraMailForwardingAddressMaxNumAddrs">100</a><a n="zimbraMailStatus">enabled</a><a n="zimbraFeatureConversationsEnabled">TRUE</a><a n="zimbraPrefCalendarReminderYMessenger">FALSE</a><a n="zimbraMobilePolicyDevicePasswordHistory">8</a><a n="zimbraMobilePolicyAllowSMIMESoftCerts">1</a><a n="zimbraPrefDeleteInviteOnReply">TRUE</a><a n="zimbraAllowAnyFromAddress">FALSE</a><a n="zimbraMobilePolicyRequireManualSyncWhenRoaming">0</a><a n="zimbraPasswordLockoutMaxFailures">10</a><a n="zimbraPrefShortEmailAddress">TRUE</a><a n="zimbraMobileSmartForwardRFC822Enabled">FALSE</a><a n="zimbraPrefForwardIncludeOriginalText">includeBody</a><a n="zimbraContactAutoCompleteEmailFields">email,email2,email3,workEmail1,workEmail2,workEmail3</a><a n="zimbraPrefShowFragments">TRUE</a><a n="zimbraMobilePolicyMaxInactivityTimeDeviceLock">15</a><a n="zimbraPrefHtmlEditorDefaultFontFamily">times new roman, new york, times, serif</a><a n="zimbraMobilePolicyAllowIrDA">1</a><a n="zimbraPasswordMinAlphaChars">0</a><a n="zimbraMobilePolicyRequireEncryptedSMIMEMessages">0</a><a n="zimbraFeatureExternalFeedbackEnabled">FALSE</a><a n="zimbraPrefComposeFormat">text</a><a n="zimbraFeatureMailForwardingEnabled">TRUE</a><a n="zimbraCalendarCalDavSharedFolderCacheDuration">1m</a><a n="zimbraPrefLocale">fr</a><a n="zimbraPrefCalendarReminderSendEmail">FALSE</a><a n="zimbraPrefContactsInitialView">list</a><a n="zimbraBatchedIndexingSize">20</a><a n="zimbraDeviceLockWhenInactive">FALSE</a><a n="zimbraPrefAutocompleteAddressBubblesEnabled">TRUE</a><a n="zimbraFeatureMailPollingIntervalPreferenceEnabled">TRUE</a><a n="zimbraPrefCalendarReminderDuration1">-PT15M</a><a n="zimbraFeatureTaggingEnabled">TRUE</a><a n="zimbraPrefIMReportIdle">TRUE</a><a n="zimbraFeaturePortalEnabled">FALSE</a><a n="zimbraPrefCalendarDefaultApptDuration">60m</a><a n="zimbraMobilePolicyAllowBrowser">1</a><a n="zimbraPrefWarnOnExit">TRUE</a><a n="zimbraMobilePolicyDevicePasswordExpiration">0</a><a n="zimbraAttachmentsIndexingEnabled">TRUE</a><a n="zimbraPrefGetMailAction">default</a><a n="zimbraPrefOutOfOfficeCacheDuration">7d</a><a n="zimbraExternalShareDomainWhitelistEnabled">FALSE</a><a n="zimbraPrefConversationOrder">dateDesc</a><a n="zimbraPrefIMHideBlockedBuddies">FALSE</a><a n="zimbraFeatureZimbraAssistantEnabled">TRUE</a><a n="zimbraPrefShowCalendarWeek">FALSE</a><a n="zimbraPrefAccountTreeOpen">TRUE</a><a n="zimbraMailWhitelistMaxNumEntries">100</a><a n="zimbraPrefIncludeTrashInSearch">FALSE</a><a n="zimbraMailHost">zimbra-pp.unicaen.fr</a><a n="zimbraMobilePolicyMinDevicePasswordLength">4</a><a n="zimbraFeatureSharingEnabled">TRUE</a><a n="zimbraPrefGalSearchEnabled">TRUE</a><a n="zimbraPrefIMHideOfflineBuddies">FALSE</a><a n="zimbraPublicShareLifetime">0</a><a n="zimbraQuotaWarnPercent">90</a><a n="zimbraDumpsterUserVisibleAge">30d</a><a n="zimbraPrefConvShowCalendar">FALSE</a><a n="zimbraFeatureGroupCalendarEnabled">TRUE</a><a n="zimbraMobilePolicyAllowStorageCard">1</a><a n="zimbraFeatureMailPriorityEnabled">TRUE</a><a n="zimbraPrefFolderTreeOpen">TRUE</a><a n="zimbraGalSyncAccountBasedAutoCompleteEnabled">TRUE</a><a n="zimbraFeatureHtmlComposeEnabled">TRUE</a><a n="zimbraPrefCalendarDayHourStart">8</a><a n="cn">Laurent LECLUSE</a><a n="zimbraFilePublicShareLifetime">0</a><a n="zimbraNewMailNotificationFrom">Postmaster &lt;postmaster@${RECIPIENT_DOMAIN}></a><a n="zimbraSpamApplyUserFilters">FALSE</a><a n="zimbraMobilePolicyAllowConsumerEmail">1</a><a n="zimbraDataSourceCalendarPollingInterval">12h</a><a n="zimbraPrefSaveToSent">TRUE</a><a n="zimbraFreebusyLocalMailboxNotActive">FALSE</a><a n="zimbraFeatureVoiceUpsellEnabled">FALSE</a><a n="zimbraDataSourceImportOnLogin">FALSE</a><a n="zimbraPrefIMLogChatsEnabled">TRUE</a><a n="zimbraSmtpRestrictEnvelopeFrom">TRUE</a><a n="zimbraFeatureManageSMIMECertificateEnabled">FALSE</a><a n="zimbraFeatureSavedSearchesEnabled">TRUE</a><a n="zimbraCalendarKeepExceptionsOnSeriesTimeChange">FALSE</a><a n="zimbraMobilePolicyPasswordRecoveryEnabled">TRUE</a><a n="mail">laurent.lecluse@pp.unicaen.fr</a><a n="zimbraPrefCalendarNotifyDelegatedChanges">FALSE</a><a n="zimbraImapEnabled">TRUE</a><a n="zimbraContactMaxNumEntries">10000</a><a n="zimbraPrefMailSignatureStyle">outlook</a><a n="zimbraFeatureFiltersEnabled">TRUE</a><a n="zimbraNewMailNotificationBody">New message received at ${RECIPIENT_ADDRESS}.${NEWLINE}Sender: ${SENDER_ADDRESS}${NEWLINE}Subject: ${SUBJECT}</a><a n="zimbraFeatureBriefcaseSlidesEnabled">FALSE</a><a n="zimbraFeatureWebSearchEnabled">TRUE</a><a n="zimbraPrefMessageViewHtmlPreferred">TRUE</a><a n="zimbraMailTrustedSenderListMaxNumEntries">500</a><a n="zimbraPrefCalendarViewTimeInterval">1h</a><a n="zimbraMobilePolicyAllowInternetSharing">1</a><a n="zimbraPrefGroupMailBy">conversation</a><a n="zimbraPasswordMinUpperCaseChars">0</a><a n="zimbraPrefContactsExpandAppleContactGroups">FALSE</a><a n="zimbraFeatureContactsEnabled">TRUE</a><a n="zimbraExternalSharingEnabled">TRUE</a><a n="zimbraPrefImapSearchFoldersEnabled">TRUE</a><a n="zimbraPrefContactsDisableAutocompleteOnContactGroupMembers">FALSE</a><a n="objectClass">inetOrgPerson</a><a n="objectClass">zimbraAccount</a><a n="objectClass">amavisAccount</a><a n="zimbraFreebusyExchangeCachedIntervalStart">7d</a><a n="zimbraMailTransport">lmtp:zimbra-pp.unicaen.fr:7025</a><a n="zimbraMailSieveScript">require ["fileinto", "reject", "tag", "flag"];

# f1
if anyof (header :contains ["subject"] "test") {
fileinto "Inbox/Essai Dest 1";
stop;
}
</a><a n="zimbraFileAndroidCrashReportingEnabled">TRUE</a><a n="zimbraPrefVoiceItemsPerPage">25</a><a n="zimbraPrefIncludeSharedItemsInSearch">FALSE</a><a n="zimbraAdminAuthTokenLifetime">12h</a><a n="zimbraMailAllowReceiveButNotSendWhenOverQuota">FALSE</a><a n="zimbraMailPurgeUseChangeDateForSpam">TRUE</a><a n="zimbraMobilePolicyAllowWiFi">1</a><a n="zimbraMobilePolicyAllowPartialProvisioning">TRUE</a><a n="zimbraStandardClientCustomPrefTabsEnabled">FALSE</a><a n="givenName">Laurent</a><a n="zimbraMailSpamLifetime">30d</a><a n="zimbraPrefIMNotifyPresence">TRUE</a><a n="zimbraMobilePolicyAllowPOPIMAPEmail">1</a><a n="zimbraPrefOpenMailInNewWindow">FALSE</a><a n="zimbraPrefHtmlEditorDefaultFontColor">#000000</a><a n="zimbraMobileMetadataMaxSizeEnabled">FALSE</a><a n="zimbraDeviceFileOpenWithEnabled">TRUE</a><a n="zimbraMobilePolicyAllowBluetooth">2</a><a n="zimbraPrefTimeZoneId">Europe/Brussels</a><a n="zimbraPrefReadingPaneLocation">right</a><a n="zimbraPrefStandardClientAccessibilityMode">FALSE</a><a n="zimbraMailIdleSessionTimeout">0</a><a n="zimbraPrefMailFlashIcon">FALSE</a><a n="zimbraFileShareLifetime">0</a><a n="zimbraPrefMailToasterEnabled">FALSE</a><a n="zimbraFeaturePop3DataSourceEnabled">FALSE</a><a n="zimbraPasswordMinDigitsOrPuncs">0</a><a n="zimbraPasswordMinAge">0</a><a n="zimbraShareLifetime">0</a><a n="zimbraMaxVoiceItemsPerPage">100</a><a n="zimbraMailBlacklistMaxNumEntries">100</a><a n="zimbraPrefTagTreeOpen">TRUE</a><a n="zimbraFeatureSocialcastEnabled">FALSE</a><a n="zimbraMobilePolicyAllowNonProvisionableDevices">TRUE</a><a n="zimbraFeatureConfirmationPageEnabled">FALSE</a><a n="zimbraFeatureGalSyncEnabled">TRUE</a><a n="zimbraPrefMailSoundsEnabled">FALSE</a><a n="zimbraFeatureTasksEnabled">TRUE</a><a n="zimbraFeatureGalAutoCompleteEnabled">TRUE</a><a n="zimbraCreateTimestamp">20131213085537Z</a><a n="zimbraMobilePolicyAlphanumericDevicePasswordRequired">FALSE</a><a n="zimbraQuotaWarnMessage">From: Postmaster &lt;postmaster@${RECIPIENT_DOMAIN}>${NEWLINE}To: ${RECIPIENT_NAME} &lt;${RECIPIENT_ADDRESS}>${NEWLINE}Subject: Quota warning${NEWLINE}Date: ${DATE}${NEWLINE}Content-Type: text/plain${NEWLINE}${NEWLINE}Your mailbox size has reached ${MBOX_SIZE_MB}MB, which is over ${WARN_PERCENT}% of your ${QUOTA_MB}MB quota.${NEWLINE}Please delete some messages to avoid exceeding your quota.${NEWLINE}</a><a n="zimbraFeatureShortcutAliasesEnabled">TRUE</a><a n="zimbraFeatureCalendarUpsellEnabled">FALSE</a><a n="zimbraFileIOSCrashReportingEnabled">TRUE</a><a n="zimbraFeatureMailSendLaterEnabled">TRUE</a><a n="zimbraPrefBriefcaseReadingPaneLocation">right</a><a n="zimbraFeatureImapDataSourceEnabled">TRUE</a><a n="zimbraPasswordLockoutDuration">1h</a><a n="zimbraMobilePolicyRefreshInterval">1440</a><a n="zimbraPasswordMinPunctuationChars">0</a><a n="zimbraMobilePolicyMaxCalendarAgeFilter">4</a><a n="zimbraFeatureDistributionListFolderEnabled">TRUE</a><a n="zimbraPrefMarkMsgRead">0</a><a n="zimbraMobilePolicyAllowCamera">1</a><a n="zimbraDataSourceMaxNumEntries">20</a><a n="zimbraFeatureImportFolderEnabled">FALSE</a><a n="zimbraDevicePasscodeEnabled">FALSE</a><a n="zimbraIMService">zimbra</a><a n="zimbraContactRankingTableSize">200</a><a n="zimbraFeaturePriorityInboxEnabled">TRUE</a><a n="zimbraPrefSkin">serenity</a><a n="zimbraAccountStatus">active</a><a n="zimbraPasswordLockoutFailureLifetime">1h</a><a n="zimbraMailOutgoingSieveScript">require ["fileinto", "reject", "tag", "flag"];

# filtre1
if allof (address :all :is :comparator "i;ascii-casemap" ["to"] "test.alias1@pp.unicaen.fr") {
fileinto "Inbox/Essai Dest 1/fgfg";
stop;
}
</a><a n="zimbraDeviceOfflineCacheEnabled">FALSE</a><a n="zimbraPrefMessageIdDedupingEnabled">TRUE</a><a n="zimbraNewMailNotificationSubject">New message received at ${RECIPIENT_ADDRESS}</a><a n="zimbraPrefIMNotifyStatus">TRUE</a><a n="zimbraPrefMailPollingInterval">500ms</a><a n="zimbraPrefDisplayExternalImages">FALSE</a><a n="zimbraPrefShowComposeDirection">FALSE</a><a n="zimbraPrefCalendarWorkingHours">1:N:0800:1700,2:Y:0800:1700,3:Y:0800:1700,4:Y:0800:1700,5:Y:0800:1700,6:Y:0800:1700,7:N:0800:1700</a><a n="zimbraPrefTasksReadingPaneLocation">right</a><a n="zimbraMailDeliveryAddress">laurent.lecluse@pp.unicaen.fr</a><a n="zimbraPrefCalendarShowPastDueReminders">TRUE</a><a n="zimbraMobilePolicyMinDevicePasswordComplexCharacters">0</a><a n="zimbraSignatureMinNumEntries">1</a><a n="zimbraPasswordEnforceHistory">0</a><a n="zimbraPrefIMFlashIcon">TRUE</a><a n="zimbraFeatureSkinChangeEnabled">TRUE</a><a n="zimbraFeatureNotebookEnabled">FALSE</a><a n="zimbraMobilePolicySuppressDeviceEncryption">FALSE</a><a n="zimbraSyncWindowSize">0</a><a n="zimbraPrefIMToasterEnabled">FALSE</a><a n="zimbraZimletAvailableZimlets">!com_zimbra_email</a><a n="zimbraZimletAvailableZimlets">!com_zimbra_url</a><a n="zimbraZimletAvailableZimlets">!com_zimbra_date</a><a n="zimbraZimletAvailableZimlets">+com_zimbra_webex</a><a n="zimbraZimletAvailableZimlets">+com_zimbra_srchhighlighter</a><a n="zimbraZimletAvailableZimlets">+com_zimbra_phone</a><a n="zimbraZimletAvailableZimlets">!com_zimbra_attachcontacts</a><a n="zimbraZimletAvailableZimlets">!com_zimbra_attachmail</a><a n="zimbraPrefCalendarApptAllowAtendeeEdit">TRUE</a><a n="zimbraArchiveAccountDateTemplate">yyyyMMdd</a><a n="zimbraInterceptSendHeadersOnly">FALSE</a><a n="zimbraMobilePolicyRequireEncryptionSMIMEAlgorithm">0</a><a n="zimbraPrefReadingPaneEnabled">TRUE</a><a n="zimbraFeatureFlaggingEnabled">TRUE</a><a n="zimbraFeatureContactsDetailedSearchEnabled">FALSE</a><a n="zimbraNotebookMaxRevisions">0</a><a n="zimbraPasswordMaxAge">0</a><a n="zimbraPrefSharedAddrBookAutoCompleteEnabled">FALSE</a><a n="zimbraJunkMessagesIndexingEnabled">TRUE</a><a n="zimbraPasswordMinLowerCaseChars">0</a><a n="zimbraMailForwardingAddressMaxLength">4096</a><a n="zimbraMailDumpsterLifetime">30d</a><a n="zimbraPrefAutoAddAddressEnabled">TRUE</a><a n="zimbraPrefIMFlashTitle">TRUE</a><a n="zimbraPrefAppleIcalDelegationEnabled">FALSE</a><a n="zimbraFeatureVoiceEnabled">FALSE</a><a n="zimbraFileExternalShareLifetime">90d</a><a n="zimbraFeatureVoiceChangePinEnabled">TRUE</a><a n="zimbraPrefOutOfOfficeStatusAlertOnLogin">TRUE</a><a n="zimbraFeatureReadReceiptsEnabled">TRUE</a><a n="zimbraSignatureMaxNumEntries">20</a><a n="zimbraPrefAutoSaveDraftInterval">30s</a><a n="zimbraMaxContactsPerPage">100</a><a n="zimbraPrefCalendarReminderFlashTitle">TRUE</a><a n="zimbraFeaturePeopleSearchEnabled">TRUE</a><a n="zimbraMobilePolicyDeviceEncryptionEnabled">TRUE</a><a n="zimbraPrefCalendarAlwaysShowMiniCal">TRUE</a><a n="zimbraPrefSearchTreeOpen">TRUE</a><a n="zimbraPrefColorMessagesEnabled">FALSE</a><a n="zimbraContactAutoCompleteMaxResults">20</a><a n="zimbraPrefCalendarReminderMobile">FALSE</a><a n="zimbraInterceptFrom">Postmaster &lt;postmaster@${ACCOUNT_DOMAIN}></a><a n="zimbraPrefCalendarApptReminderWarningTime">5</a><a n="zimbraIdentityMaxNumEntries">20</a><a n="zimbraMailThreadingAlgorithm">references</a><a n="zimbraFeatureDiscardInFiltersEnabled">TRUE</a><a n="zimbraFeatureNewMailNotificationEnabled">TRUE</a><a n="zimbraPrefContactsPerPage">25</a><a n="zimbraPrefIMInstantNotify">TRUE</a><a n="zimbraFeatureAdminMailEnabled">TRUE</a><a n="zimbraPrefPop3IncludeSpam">FALSE</a><a n="zimbraFeatureMailForwardingInFiltersEnabled">TRUE</a><a n="zimbraPrefIMIdleTimeout">10</a><a n="zimbraMailTrashLifetime">30d</a><a n="zimbraFeatureOptionsEnabled">TRUE</a><a n="zimbraPasswordLocked">FALSE</a><a n="zimbraPop3Enabled">FALSE</a><a n="zimbraId">01d13c21-2d2c-45f9-9df0-9bee295b3542</a><a n="zimbraMobilePolicyRequireSignedSMIMEMessages">0</a><a n="zimbraContactEmailFields">email,email2,email3,email4,email5,email6,email7,email8,email9,email10,workEmail1,workEmail2,workEmail3</a><a n="zimbraMobilePolicyAllowRemoteDesktop">1</a><a n="zimbraWebClientShowOfflineLink">TRUE</a><a n="zimbraFilterSleepInterval">1ms</a><a n="zimbraMailQuota">0</a><a n="zimbraPrefPop3DeleteOption">delete</a><a n="zimbraMobilePolicyMaxEmailHTMLBodyTruncationSize">-1</a><a n="zimbraFeatureAdvancedSearchEnabled">TRUE</a><a n="zimbraMobilePolicyAllowSMIMEEncryptionAlgorithmNegotiation">2</a><a n="zimbraPrefZimletTreeOpen">FALSE</a><a n="zimbraAuthTokenLifetime">2d</a><a n="zimbraPrefComposeInNewWindow">FALSE</a><a n="zimbraPrefCalendarAllowPublishMethodInvite">FALSE</a><a n="zimbraFeatureGalEnabled">TRUE</a><a n="sn">LECLUSE</a><a n="zimbraMobilePolicyRequireSignedSMIMEAlgorithm">0</a><a n="zimbraFeatureInstantNotify">TRUE</a><a n="zimbraMobilePolicyRequireDeviceEncryption">0</a><a n="zimbraMailSignatureMaxLength">10240</a><a n="zimbraDumpsterPurgeEnabled">TRUE</a><a n="zimbraDumpsterEnabled">TRUE</a><a n="zimbraFeatureViewInHtmlEnabled">FALSE</a><a n="zimbraPrefUseKeyboardShortcuts">TRUE</a><a n="zimbraPrefUseRfc2231">FALSE</a><a n="zimbraPrefMailSelectAfterDelete">next</a><a n="zimbraPrefDedupeMessagesSentToSelf">dedupeNone</a><a n="zimbraDeviceAllowedPasscodeLockoutDuration">10m</a><a n="zimbraDeviceAllowedPasscodeLockoutDuration">1m</a><a n="zimbraDeviceAllowedPasscodeLockoutDuration">2m</a><a n="zimbraDeviceAllowedPasscodeLockoutDuration">30m</a><a n="zimbraDeviceAllowedPasscodeLockoutDuration">5m</a><a n="zimbraMailMinPollingInterval">0s</a><a n="zimbraPrefCalendarShowDeclinedMeetings">TRUE</a><a n="zimbraFeatureMAPIConnectorEnabled">TRUE</a><a n="zimbraPrefCalendarInitialView">workWeek</a><a n="zimbraAttachmentsBlocked">FALSE</a><a n="zimbraPrefUseTimeZoneListInCalendar">FALSE</a><a n="zimbraCalendarResourceDoubleBookingAllowed">TRUE</a><a n="zimbraFeatureIdentitiesEnabled">FALSE</a><a n="zimbraFeatureFreeBusyViewEnabled">FALSE</a><a n="zimbraPrefJunkLifetime">0</a><a n="zimbraPrefExternalSendersType">ALL</a><a n="zimbraPrefForwardReplyPrefixChar">></a><a n="zimbraExternalAccountLifetimeAfterDisabled">30d</a><a n="zimbraInterceptBody">Intercepted message for ${ACCOUNT_ADDRESS}.${NEWLINE}Operation=${OPERATION}, folder=${FOLDER_NAME}, folder ID=${FOLDER_ID}.</a><a n="zimbraCalendarShowResourceTabs">TRUE</a><a n="zimbraPasswordModifiedTime">20131213085537Z</a><a n="zimbraPrefFolderColorEnabled">TRUE</a><a n="zimbraLastLogonTimestamp">20131213085852Z</a><a n="zimbraPrefAdminConsoleWarnOnExit">TRUE</a><a n="zimbraFeatureNewAddrBookEnabled">TRUE</a><a n="displayName">Laurent LECLUSE</a><a n="zimbraPasswordMinLength">6</a><a n="zimbraMobilePolicyAllowHTMLEmail">1</a><a n="zimbraPrefCalendarSendInviteDeniedAutoReply">TRUE</a><a n="userPassword">VALUE-BLOCKED</a><a n="zimbraAttachmentsViewInHtmlOnly">FALSE</a><a n="zimbraPrefConvReadingPaneLocation">bottom</a><a n="zimbraPrefItemsPerVirtualPage">50</a><a n="zimbraMailPurgeUseChangeDateForTrash">TRUE</a><a n="zimbraPrefShowSelectionCheckbox">FALSE</a><a n="zimbraPrefSentLifetime">0</a><a n="zimbraFeatureOutOfOfficeReplyEnabled">TRUE</a><a n="zimbraFeatureMobilePolicyEnabled">TRUE</a><a n="zimbraFeatureDistributionListExpandMembersEnabled">TRUE</a><a n="zimbraFeatureBriefcasesEnabled">TRUE</a><a n="zimbraPrefGalAutoCompleteEnabled">TRUE</a><a n="zimbraPrefSentMailFolder">sent</a><a n="zimbraPrefSpellIgnoreAllCaps">TRUE</a><a n="zimbraPrefAdvancedClientEnforceMinDisplay">TRUE</a><a n="zimbraMobilePolicyDevicePasswordEnabled">TRUE</a><a n="zimbraMailMessageLifetime">0</a><a n="zimbraFeatureInitialSearchPreferenceEnabled">TRUE</a><a n="zimbraFeatureAntispamEnabled">TRUE</a><a n="zimbraInterceptSubject">Intercepted message for ${ACCOUNT_ADDRESS}: ${MESSAGE_SUBJECT}</a><a n="zimbraPrefIMLogChats">TRUE</a><a n="zimbraPrefCalendarAutoAddInvites">TRUE</a><a n="zimbraPrefInboxReadLifetime">0</a><a n="zimbraPrefShowSearchString">FALSE</a><a n="zimbraNotebookSanitizeHtml">TRUE</a><a n="zimbraFeatureCrocodocEnabled">FALSE</a><a n="zimbraFeatureIMEnabled">FALSE</a><a n="zimbraPrefForwardReplyInOriginalFormat">TRUE</a><a n="zimbraPrefDefaultPrintFontSize">12pt</a><a n="zimbraArchiveAccountNameTemplate">${USER}-${DATE}@${DOMAIN}.archive</a><a n="zimbraFeatureSignaturesEnabled">TRUE</a><a n="zimbraPasswordMinNumericChars">0</a><a n="zimbraFeatureCalendarEnabled">TRUE</a><a n="zimbraPrefClientType">advanced</a><a n="zimbraFeatureMailUpsellEnabled">FALSE</a><a n="zimbraMailHighlightObjectsMaxSize">70</a><a n="zimbraPrefMailRequestReadReceipts">FALSE</a><a n="zimbraFileUploadMaxSizePerFile">2147483648</a><a n="zimbraFeatureMobileSyncEnabled">FALSE</a><a n="zimbraPrefInboxUnreadLifetime">0</a><a n="zimbraExternalShareLifetime">0</a><a n="zimbraPrefMailSendReadReceipts">never</a><a n="zimbraFeatureSocialFiltersEnabled">Facebook</a><a n="zimbraFeatureSocialFiltersEnabled">LinkedIn</a><a n="zimbraFeatureSocialFiltersEnabled">SocialCast</a><a n="zimbraFeatureSocialFiltersEnabled">Twitter</a><a n="zimbraMobilePolicyMaxEmailAgeFilter">2</a><a n="zimbraQuotaWarnInterval">1d</a><a n="zimbraPrefAutoCompleteQuickCompletionOnComma">TRUE</a><a n="uid">laurent.lecluse</a><a n="zimbraMobilePolicyAllowUnsignedInstallationPackages">1</a><a n="zimbraFeatureExportFolderEnabled">TRUE</a><a n="zimbraDataSourceRssPollingInterval">12h</a><a n="zimbraCalendarMaxRevisions">1</a><a n="zimbraPrefHtmlEditorDefaultFontSize">12pt</a><a n="zimbraMobilePolicyAllowDesktopSync">1</a><a n="zimbraFeatureCalendarReminderDeviceEmailEnabled">FALSE</a><a n="zimbraPrefCalendarAllowForwardedInvite">TRUE</a><a n="zimbraFeatureBriefcaseDocsEnabled">TRUE</a><a n="zimbraPasswordMaxLength">64</a><a n="zimbraMobilePolicyAllowTextMessaging">1</a><a n="zimbraFilterBatchSize">10000</a><a n="zimbraMobilePolicyMaxDevicePasswordFailedAttempts">4</a><a n="zimbraPrefIncludeSpamInSearch">FALSE</a><a n="zimbraFeatureChangePasswordEnabled">TRUE</a><a n="zimbraFeatureMailEnabled">TRUE</a><a n="zimbraPrefMailItemsPerPage">25</a><a n="zimbraPrefReplyIncludeOriginalText">includeBody</a><a n="zimbraFeatureSMIMEEnabled">FALSE</a><a n="zimbraFeatureContactsUpsellEnabled">FALSE</a><a n="zimbraMobilePolicyMaxEmailBodyTruncationSize">-1</a><a n="zimbraPrefCalendarFirstDayOfWeek">1</a><a n="zimbraPrefMailInitialSearch">in:inbox</a><a n="zimbraPortalName">example</a><a n="zimbraFreebusyExchangeCachedInterval">60d</a><a n="zimbraPrefCalendarAllowCancelEmailToSelf">FALSE</a><a n="zimbraFeatureImportExportFolderEnabled">TRUE</a><a n="zimbraPrefCalendarReminderSoundsEnabled">TRUE</a><a n="zimbraPrefTrashLifetime">0</a><a n="zimbraMobilePolicyAllowSimpleDevicePassword">FALSE</a><a n="zimbraPrefCalendarDayHourEnd">18</a><a n="zimbraArchiveEnabled">FALSE</a><a n="zimbraFeatureOpenMailInNewWindowEnabled">TRUE</a><a n="zimbraZimletLoadSynchronously">FALSE</a><a n="zimbraPublicSharingEnabled">TRUE</a><a n="zimbraPrefIMSoundsEnabled">TRUE</a><a n="zimbraFeatureBriefcaseSpreadsheetEnabled">FALSE</a><a n="zimbraPrefMandatorySpellCheckEnabled">FALSE</a><a n="zimbraPrefIMIdleStatus">away</a><a n="zimbraDataSourceMinPollingInterval">1m</a><a n="zimbraPrefIMAutoLogin">FALSE</a><a n="zimbraPrefFileSharingApplication">briefcase</a><a n="zimbraMaxMailItemsPerPage">100</a><a n="zimbraFeatureManageZimlets">TRUE</a><a n="zimbraPasswordLockoutEnabled">FALSE</a><a n="zimbraPrefSortOrder">2:dateDesc,BDLV:,BDLV-main:subjAsc,CAL:,CLV:,CLV-main:dateDesc,CNS:,CNSRC:,CNTGT:,CV:,TKL:,TV:,dumpsterMail:dateDesc</a><a n="zimbraPrefCalendarToasterEnabled">FALSE</a><a n="zimbraPrefCalendarApptVisibility">public</a><a n="zimbraPrefCalendarUseQuickAdd">TRUE</a><a n="zimbraFeatureComposeInNewWindowEnabled">TRUE</a></account></GetAccountResponse>';

    protected function setUp()
    {
        $this->account = new Account;
    }

    public function testPopulate()
    {
        $id = '01d13c21-2d2c-45f9-9df0-9bee295b3542';

        $node = new \SimpleXMLElement( $this->xmlData );
        $this->account->populate( $node->children()[0] );

        $this->assertEquals($id, $this->account->getId());
        $this->assertTrue($this->account->zimbraPrefMessageIdDedupingEnabled);
        return $this->account;
    }

    /**
     * @depends testPopulate
     * @param Account $account
     */
    public function testSetName(Account $account)
    {
        $name = 'test.test@pp.unicaen.fr';
        $account->setName( $name );
        $this->assertEquals($name, $account->getName());
    }

    /**
     * @depends testPopulate
     * @param \UnicaenZimbra\Entity\Account $account
     */
    public function testArrayExchanges(Account $account)
    {
        $properties = array(
            'zimbraPrefIMNotifyPresence' => false,
            'givenName' => 'Robert',
            'displayName' => 'Robert Denis Rault',
        );
        $account->exchangeArray($properties);
        $res = $account->getArrayCopy();
        $result = array();
        foreach( $properties as $key => $value ){
            $result[$key] = $res[$key];
            $this->assertEquals($value, $account->$key);
        }

        $this->assertEquals($properties, $result);

        $result = $account->getConvertedChanges();
        $this->assertEquals('FALSE', $result['zimbraPrefIMNotifyPresence']);
    }

}