<?php

namespace UnicaenZimbraTest\Service;

use PHPUnit_Framework_TestCase;
use UnicaenZimbra\Service\MailBox;
use UnicaenZimbra\Entity\MailBox as MailBoxEntity;

/**
 * @group MailBox
 */
class MailBoxTest extends PHPUnit_Framework_TestCase
{
    /**
     *
     * @var MailBox
     */
    protected $service;

    protected $data = array(
        'accountId' => '01d13c21-2d2c-45f9-9df0-9bee295b3542' // laurent.lecluse@pp.unicaen.fr
    );

    protected function setUp()
    {
        \UnicaenZimbraTest\Bootstrap::getServiceManager()->get('zimbra')->connect();
        $this->service = \UnicaenZimbraTest\Bootstrap::getServiceManager()->get('zimbraServiceMailBox');
    }

    public function testGetList()
    {
        $id = $this->data['accountId'];

        $res = $this->service->getList(100);
        $this->assertArrayHasKey($id, $res);
        $this->assertInstanceOf('\UnicaenZimbra\Entity\MailBox', $res[$id]);
        $this->assertEquals($id, $res[$id]->getId());
    }

    public function testGet()
    {
        $id = $this->data['accountId'];

        $res = $this->service->get($id);
        $this->assertInstanceOf('\UnicaenZimbra\Entity\MailBox', $res);
        $this->assertEquals($id, $res->getId());
    }
}